import cloneDeep from 'lodash/cloneDeep';
import { freezeSys, toPlainObject } from 'contentful-sdk-core';
import enhanceWithMethods from '../enhance-with-methods';

function createPreviewApiKeyApi() {
  return {};
}
/**
 * @private
 * @param http - HTTP client instance
 * @param data - Raw api key data
 * @return Wrapped preview api key data
 */


export function wrapPreviewApiKey(_http, data) {
  var previewApiKey = toPlainObject(cloneDeep(data));
  enhanceWithMethods(previewApiKey, createPreviewApiKeyApi());
  return freezeSys(previewApiKey);
}
/**
 * @private
 * @param http - HTTP client instance
 * @param data - Raw api key collection data
 * @return Wrapped api key collection data
 */

export function wrapPreviewApiKeyCollection(http, data) {
  var previewApiKeys = toPlainObject(cloneDeep(data));
  previewApiKeys.items = previewApiKeys.items.map(function (entity) {
    return wrapPreviewApiKey(http, entity);
  });
  return freezeSys(previewApiKeys);
}