import cloneDeep from 'lodash/cloneDeep';
import { freezeSys, toPlainObject } from 'contentful-sdk-core';

/**
 * @private
 * @param http - HTTP client instance
 * @param data - Raw space member data
 * @return Wrapped space member data
 */
export function wrapSpaceMember(http, data) {
  var spaceMember = toPlainObject(cloneDeep(data));
  return freezeSys(spaceMember);
}
/**
 * @private
 * @param http - HTTP client instance
 * @param data - Raw space members collection data
 * @return Wrapped space members collection data
 */

export function wrapSpaceMemberCollection(http, data) {
  var spaceMembers = toPlainObject(cloneDeep(data));
  spaceMembers.items = spaceMembers.items.map(function (entity) {
    return wrapSpaceMember(http, entity);
  });
  return freezeSys(spaceMembers);
}