import { createCMAHttpClient } from '../create-cma-http-client';
import * as endpoints from './index';
import { wrap } from './wrappers/wrap';
export var createPlainClient = function createPlainClient(params, defaults) {
  var http = createCMAHttpClient(params);
  var wrapParams = {
    http: http,
    defaults: defaults
  };
  return {
    space: {
      get: wrap(wrapParams, endpoints.space.get),
      update: wrap(wrapParams, endpoints.space.update),
      "delete": wrap(wrapParams, endpoints.space["delete"])
    },
    environment: {
      get: wrap(wrapParams, endpoints.environment.get),
      update: wrap(wrapParams, endpoints.environment.update)
    },
    contentType: {
      getMany: wrap(wrapParams, endpoints.contentType.getMany)
    },
    user: {
      getManyForSpace: wrap(wrapParams, endpoints.user.getManyForSpace)
    },
    entry: {
      getMany: wrap(wrapParams, endpoints.entry.getMany),
      get: wrap(wrapParams, endpoints.entry.get),
      update: wrap(wrapParams, endpoints.entry.update),
      "delete": wrap(wrapParams, endpoints.entry["delete"]),
      publish: wrap(wrapParams, endpoints.entry.publish),
      unpublish: wrap(wrapParams, endpoints.entry.unpublish),
      archive: wrap(wrapParams, endpoints.entry.archive),
      unarchive: wrap(wrapParams, endpoints.entry.unarchive),
      create: wrap(wrapParams, endpoints.entry.create),
      createWithId: wrap(wrapParams, endpoints.entry.createWithId)
    },
    locale: {
      getMany: wrap(wrapParams, endpoints.locale.getMany)
    },
    raw: {
      getDefaultParams: function getDefaultParams() {
        return defaults;
      },
      get: function (_get) {
        function get() {
          return _get.apply(this, arguments);
        }

        get.toString = function () {
          return _get.toString();
        };

        return get;
      }(function () {
        var _endpoints$raw;

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return (_endpoints$raw = endpoints.raw).get.apply(_endpoints$raw, [http].concat(args));
      }),
      post: function (_post) {
        function post() {
          return _post.apply(this, arguments);
        }

        post.toString = function () {
          return _post.toString();
        };

        return post;
      }(function () {
        var _endpoints$raw2;

        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        return (_endpoints$raw2 = endpoints.raw).post.apply(_endpoints$raw2, [http].concat(args));
      }),
      put: function (_put) {
        function put() {
          return _put.apply(this, arguments);
        }

        put.toString = function () {
          return _put.toString();
        };

        return put;
      }(function () {
        var _endpoints$raw3;

        for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
          args[_key3] = arguments[_key3];
        }

        return (_endpoints$raw3 = endpoints.raw).put.apply(_endpoints$raw3, [http].concat(args));
      }),
      "delete": function _delete() {
        var _endpoints$raw4;

        for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          args[_key4] = arguments[_key4];
        }

        return (_endpoints$raw4 = endpoints.raw)["delete"].apply(_endpoints$raw4, [http].concat(args));
      }
    }
  };
};